<?php


/*--------------------------------------------------------------------

	Ŭ :: DBControl 1.0.0

	 :: 2002-04-19
	 :: 2003-01-24

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class DBControl {


	var $host_name;
	var $user_name;
	var $user_pass;
	var $db_name;

	var $link_id;
	var $result_id;



	/*

	  (Constructor) Ѵ.

	 void DBControl(string host_name, string user_name, string user_pass, string db_name)
	 ex) DBControl("localhost", "userid", "userpass", "dbname")

	*/

	function DBControl($host_name, $user_name, $user_pass, $db_name) {

		$this->host_name = $host_name;
		$this->user_name = $user_name;
		$this->user_pass = $user_pass;
		$this->db_name = $db_name;

	}



	/*

	 Ÿ̽  Ѵ.

	 public boolean connect()
	 ex) connect()

	*/

	function connect() {

		$this->link_id = mysql_connect($this->host_name, $this->user_name, $this->user_pass) or $this->report(mysql_errno() . " " . mysql_error(), "err");
		$db_select_status = mysql_select_db($this->db_name, $this->link_id) or $this->report(mysql_errno() . " " . mysql_error(), "err");

		if ($this->link_id and $db_select_status) return true;
		else return false;

	}



	/*

	 Ÿ Ѵ. ( !)

	 public boolean open(string query)
	 ex) open("SELECT * FROM test")

	*/

	function open($query) {

		if ($this->result_id = mysql_query($query, $this->link_id) or $this->report(mysql_errno() . " " . mysql_error(), "err")) return true;
		else return false;

	}



	/*

	  Ѵ. ( !)

	 public boolean execute(string query)
	 ex) execute("UPDATE test SET a = 'ok' WHERE uid = 1")

	*/

	function execute($query) {

		if ($result_id = mysql_query($query, $this->link_id) or $this->report(mysql_errno() . " " . mysql_error(), "err")) return true;
		else return false;

	}



	/*

	 ֱ Էκ  ̵ Ѵ.

	 public int getInsertId()
	 ex) getInsertId()

	*/

	function getInsertId() {

		$return_value = mysql_insert_id($this->link_id) or $this->report(mysql_errno() . " " . mysql_error(), "err");

		return $return_value;

	}



	/*

	      ͸ ű.

	 public boolean seek(int row_num)
	 ex) seek(2)

	*/

	function seek($row_num) {

		$return_value = mysql_data_seek($this->result_id, $row_num) or $this->report(mysql_errno() . " " . mysql_error(), "err");

		return $return_value;

	}



	/*

	      迭 ȯѴ.

	 public array fetch()
	 ex) fetch()

	*/

	function fetch() {

		if (! $this->result_id) $this->report("DBκ ҷ  ϴ.", "err");

		if ($ary_row = mysql_fetch_array($this->result_id)) {

			$ary_row2 = array();

			foreach ($ary_row as $key => $value) {

				$ary_row2[$key] = is_string($value) ? stripslashes($value) : $value;

			}

			return $ary_row2;

		} else { return; }

	}



	/*

	  ڵ  ȯѴ.

	 public int count()
	 ex) count()

	*/

	function count() {

		$return_value = mysql_num_rows($this->result_id) or $this->report(mysql_errno() . " " . mysql_error(), "err");

		return $return_value;

	}



	/*

	  ޸  ȯѴ.

	 public boolean free()
	 ex) free()

	*/

	function free() {

		$return_value = mysql_free_result($this->result_id) or $this->report(mysql_errno() . " " . mysql_error(), "err");

		return $return_value;

	}



	/*

	 Ÿ̽   Ѵ.

	 public boolean close()
	 ex) close()

	*/

	function close() {

		$return_value = mysql_close($this->link_id) or $this->report(mysql_errno() . " " . mysql_error(), "err");

		return $return_value;

	}



	/*

	 α׸ Ѵ.

	 private void report(string msg, string mode)
	 ex) report("  test.php()   µ Ͽϴ.", "err")

	*/

	function report($msg, $mode) {

		if (isset($GLOBALS[Log])) $GLOBALS[Log]->report($msg, $mode);

	}


}




/*--------------------------------------------------------------------

	Ŭ :: SonDBControl 1.0.0

	 :: 2002-04-23
	 :: 2003-03-11

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class SonDBControl extends DBControl {


	/*

	 Ÿ     迭 ȯѴ.

	 public Array fetchOpen(string query)
	 ex) fetchOpen("SELECT  * FROM test")

	*/

	function fetchOpen($query) {

		return $this->fetch($this->open($query));

	}



	/*

	 ο Ÿ Ѵ.

	 public boolean insert(string table, array ary_data)
	 ex) insert("test", array("a" => "ok"))

	*/

	function insert($table, $ary_data) {

		$fields = "";
		$values = "";

		foreach ($ary_data as $key => $value) {

			$fields .= $key . ", ";
			$values .= "'" . (is_string($value) ? addslashes($value) : $value) . "', ";

		}

		$fields = substr($fields, 0, -2);
		$values = substr($values, 0, -2);

		if (! $this->execute("INSERT INTO $table ($fields) VALUES ($values)")) return false;
		else return true;

	}



	/*

	 Ÿ Ѵ.

	 public boolean update(string table, array ary_data[, string where])
	 ex) update("test", array("a" => "ok"), "uid = 1"), update("test", array("a" => "ok"))

	*/

	function update($table, $ary_data, $where = "") {

		if ($ary_data[sums_key]) {

			$sums_key = $ary_data[sums_key];

			array_splice($ary_data, -1);

		} else {

			$sums_key = "";

		}

		$set_data = "";

		foreach ($ary_data as $key => $value) {

			if (preg_match("/,*\s*($key)\s*,*/", $sums_key)) $set_data .= $key . " = " . $value . ", ";
			else $set_data .= $key . " = '" . (is_string($value) ? addslashes($value) : $value) . "', ";

		}

		$set_data2 = substr($set_data, 0, -2);

		if ($where) $where = " WHERE " . $where;

		if (! $this->execute("UPDATE " . $table . " SET " . $set_data2 . $where)) return false;
		else return true;

	}



	/*

	 Ÿ Ѵ.

	 public boolean delete(string table[, string where])
	 ex) delete("test", "uid = 1"), delete("test")

	*/

	function delete($table, $where = "") {

		if (! $this->execute("DELETE FROM " . $table . ($where ? " WHERE " . $where : ""))) return false;
		else return true;

	}



	/*

	 Ѱܹ  ̺ ̸ ȮѴ.

	 public boolean isTable(string db, string|array mix_table[, string all])
	 ex) isTable("test", "test"), isTable("test", array("test", "test2"), 1)

	*/

	function isTable($db, $mix_table, $all = 0) {

		if (! is_array($mix_table)) $mix_table[0] = $mix_table;

		$this->open("SHOW TABLES FROM $db");
		$ary_exist_table = array();

		while ($ary_exist_table_info = $this->fetch()) {

			$ary_exist_table[] = $ary_exist_table_info[0];

		}

		$match_count = 0;

		foreach($mix_table as $table) {

			if (in_array($table, $ary_exist_table)) $match_count++;

		}

		if (($all == 1) and ($match_count == (count($mix_table) + 1))) return true;
		elseif (($all == 0) and $match_count) return true;
		else return false;

	}



	/*

	 ̺ Ѵ.

	 public boolean dropTable(string|array mix_table)
	 ex) dropTable("test"), dropTable(array("test", "test2"))

	*/

	function dropTable($mix_table) {

		$tables = (! is_array($mix_table)) ? $mix_table : implode($mix_table, ", ");

		if (! $this->execute("DROP TABLE $tables")) return false;
		else return true;

	}



	/*

	 ̺  Ǵ.

	 public boolean lock(string table[, string mode])
	 ex) lock("test", "w")

	*/

	function lock($table, $mode = "w") {

		if (($mode != "w") and ($mode != "r")) {

			$this->report("ش 尡  ʽϴ. (Ŭ SonDBControl ޼ҵ lock)", "err");

			return false;

		}

		if ($mode == "w") {

			$result_id = $this->execute("LOCK TABLES $table WRITE", $this->link_id);

		} elseif ($mode == "r") {

			$result_id = $this->execute("LOCK TABLES $table READ", $this->link_id);

		}

		if ($result_id) return true;
		else return false;

	}



	/*

	 ̺ ɸ  Ѵ.

	 public boolean unlock()
	 ex) unlock()

	*/

	function unlock() {

		if (! $this->execute("UNLOCK TABLES", $this->link_id)) return false;
		else return true;

	}


}




/*--------------------------------------------------------------------

	Ŭ :: FSControl 1.0.0

	 :: 2002-04-21
	 :: 2003-04-24

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class FSControl {


	var $fp;
	var $ary_del_allow_dir = array("./data1", "./data2", "./skins", "./log", "./auth");

	var $upload_dir;
	var $is_ary_upfile;
	var $ary2_upfile;
	var $upload_error;

	var $lock_file;
	var $more;
	var $wait_time = 5;
	var $fp2;



	/*

	 Ÿ Ͽ Ѵ.

	 public boolean put(string filename, string contents)
	 ex) put("./test.txt", "test")

	*/

	function put($filename, $contents) {

		$this->fp = fopen($filename, "w");

		if (! $this->fp) {

			$this->report(" ${filename}()   µ Ͽϴ.", "err");

			return false;

		}

		fwrite($this->fp, $contents);
		fclose($this->fp);

		return true;

	}



	/*

	 Ÿ Ͽ ߰Ѵ.

	 public boolean add(string filename, string contents)
	 ex) add("./test.txt", "test")

	*/

	function add($filename, $contents) {

		$this->fp = fopen($filename, "a");

		if (! $this->fp) {

			$this->report(" ${filename}() ߰  µ Ͽϴ.", "err");

			return false;

		}

		fwrite($this->fp, $contents);
		fclose($this->fp);

		return true;

	}



	/*

	 Ͽ ϵ Ÿ оδ.

	 public string get(string filename)
	 ex) get("./test.txt")

	*/

	function get($filename) {

		$this->fp = fopen($filename, "r");

		if (! $this->fp) {

			$this->report(" ${filename}() б  µ Ͽϴ.", "err");

			return;

		}

		$contents = fread($this->fp, filesize($filename));
		fclose($this->fp);

		return $contents;

	}



	/*

	 ̳  ϴ ȮѴ.

	 public boolean exist(string filename)
	 ex) exist("./test.txt")

	*/

	function exist($filename) {

		if (! file_exists($filename)) return false;
		else return true;

	}



	/*

	 ο  Ȥ  Ѵ.

	 public boolean create(string pathname[, int mode[, string trait]])
	 ex) create("./test.txt", 0755, "file"), create("./test", 0755), , create("./test")

	*/

	function create($pathname, $mode = 0644, $trait = "dir") {

		if ($trait == "file") {

			touch($pathname);
			$this->setMode($pathname, $mode);

			if (! is_file($pathname)) {

				$this->report(" ${pathname}() ϴµ Ͽϴ.", "err");

				return false;

			}

		} elseif ($trait == "dir") {

			if (! mkdir($pathname, $mode)) {

				$this->report(" ${pathname}() ϴµ Ͽϴ.", "err");

				return false;

			}

		} else {

			$this->report("ش簪 ${pathname}()  Ȥ  ƴմϴ.", "err");

			return false;

		}

		return true;

	}



	/*

	 ش ̳  Ѵ. [  ]

	 public boolean delete(string|array filename)
	 ex) delete("./test"), delete(array("./test", "/test2")

	*/

	function delete($mix_filename) {

		if (! is_array($mix_filename)) $ary_filename[0] = $mix_filename;
		else $ary_filename = $mix_filename;

		foreach ($ary_filename as $filename) {

			if (is_file($filename)) {

				if (! $this->deleteFile($filename)) {

					$this->report(" ${filename}() ϴµ Ͽϴ.", "err");

					return false;

				}

			} elseif (is_dir($filename)) {

				$del_ok = false;

				foreach ($this->ary_del_allow_dir as $del_allow_dir) {

					if (preg_match("|^" . $del_allow_dir . "|m", $filename)) {

						$del_ok = true;

					}

					if (preg_match("|/$|m", $filename)) {

						$this->report("ش簪 ${filename}()  Ȥ   ȣ Դϴ.", "err");

						return false;

					}

				}

				if (! $del_ok) {

					$this->report(" ${filename}()    ƴմϴ.", "err");

					return false;

				}

				if (! $this->deleteDir($filename)) {

					$this->report(" ${filename}() ϴµ Ͽϴ.", "err");

					return false;

				}

			} else {

				$this->report("ش簪 ${filename}()  Ȥ  ƴմϴ.", "err");

				return false;

			}

		}

		return true;

	}



	/*

	  Ѵ.

	 private boolean deleteFile(string filename)
	 ex) deleteFile("./test.txt")

	*/

	function deleteFile($filename) {

		chmod($filename, 0777);

		if (! unlink($filename)) return flase;
		else return true;

	}



	/*

	  Ѵ.

	 private boolean deleteDir(string $dirname)
	 ex) deleteDir("./test")

	*/

	function deleteDir($dirname) {

		$dir_handle = opendir($dirname);

		if (! $dir_handle) {

			$this->report(" ${dirname}() µ Ͽϴ.", "err");

			return false;

		}

		while ($filename = readdir($dir_handle)) {

			if ($filename != "." and $filename != "..") {

				chmod($dirname . "/" . $filename, 0777);

				if (is_dir($dirname . "/" . $filename)) $this->deleteDir($dirname . "/" . $filename);
				else $this->deleteFile($dirname . "/" . $filename);

			}

		}

		closedir($dir_handle);

		chmod($dirname, 0777);
		rmdir($dirname);

		if ($this->exist($dirname)) return false;
		else return true;

	}



	/*

	 ش ̳  Ѵ.

	 public boolean copy(string filename, string dest)
	 ex) copy("./test", "./test2"), copy("./test.txt", "./test2.txt")

	*/

	function copy($filename, $dest) {

		if (is_file($filename)) {

			if (! $this->copyFile($filename, $dest)) {

				$this->report(" ${filename}() ϴµ Ͽϴ.", "err");

				return false;

			}

		} elseif (is_dir($filename)) {

			if (! $this->copyDir($filename, $dest)) {

				$this->report(" ${filename}() ϴµ Ͽϴ.", "err");

				return false;

			}

		} else {

			$this->report("ش簪 ${filename}()  Ȥ  ƴմϴ.", "err");

			return false;

		}

		return true;

	}



	/*

	  Ѵ.

	 private boolean copyFile(string filename, string dest)
	 ex) copyFile("./test.txt", "./test2.txt")

	*/

	function copyFile($file, $dest) {

		if (! copy($file, $dest)) return false;
		else return true;

	}



	/*

	  Ѵ.

	 private boolean copyDir(string dirname, string dest)
	 ex) copyDir("./test", "./test2")

	*/

	function copyDir($dirname, $dest) {

		if ((! is_dir($dest)) and (! $this->create($dest, 0777))) return false;

		$dir_handle = opendir($dirname);

		if (! $dir_handle) {

			$this->report(" ${dirname}() µ Ͽϴ.", "err");

			return false;

		}

		while ($filename = readdir($dir_handle)) {

			if ($filename != "." and $filename != "..") {

				if (is_dir($dirname . "/" . $filename)) {

					if (! $this->copyDir($dirname . "/" . $filename, $dest . "/" . $filename)) return false;

				} elseif (! $this->copyFile($dirname . "/" . $filename, $dest . "/" . $filename)) return false;

			}

		}

		closedir($dir_handle);

		return true;

	}



	/*

	  Ȥ  ̸ Ѵ.

	 public boolean rename(string old_name, string new_name)
	 ex) rename("./test.txt", "./test2.txt")

	*/

	function rename($old_name, $new_name) {

		if (! rename($old_name, $new_name)) return false;
		return true;

	}



	/*

	 ش ̳  ۹̼ ȯѴ.

	 public int getMode(string filename[, int length])
	 ex) getMode("./test.txt", 3)

	*/

	function getMode($filename, $length = 3) {

		if (! $this->exist($filename)) {

			$this->report(" Ȥ  ${filename}()  ʽϴ.", "err");

			return;

		}

		$mode = decoct(fileperms($filename));

		return substr($mode, $length * -1);

	}



	/*

	 ش ̳ Ͽ ۹̼ οѴ.

	 public boolean setMode(string filename, int mode[, int all])
	 ex) setMode("./test.txt", 0755), setMode("./test", 0755, 1)

	*/

	function setMode($filename, $mode, $all = 0) {

		if (! $this->exist($filename)) {

			$this->report(" Ȥ  ${filename}()  ʽϴ.", "err");

			return false;

		}

		if ($all) {

			if (! $this->setModeAll($filename, $mode)) return false;

		} else {

			if (! chmod($filename, $mode)) return false;

		}

		return true;

	}



	/*

	 ش    ̳ Ͽ   ϰ οѴ.

	 private boolean setModeAll(string dirname, int mode)
	 ex) setModeAll("./test", 0755)

	*/

	function setModeAll($dirname, $mode) {

		$this->setMode($dirname, $mode);

		$dir_handle = opendir($dirname);

		while ($filename = readdir($dir_handle)) {

			if ($filename != "." and $filename != "..") {

				if (is_dir($dirname . "/" . $filename)) {

					if (! $this->setModeAll($dirname . "/" . $filename, $mode)) return false;

				} elseif (! $this->setMode($dirname . "/" . $filename, $mode)) return false;

			}

		}

		closedir($dir_handle);

		return true;

	}



	/*

	  εϱ   ʱȭѴ.

	 public boolean baseUpload(array ary_upfile, string base_dir)
	 ex) baseUpload($ary_upfile, "./test")

	*/

	function baseUpload($ary_upfile, $base_dir) {

		if (! is_array($ary_upfile[name])) {

			$this->is_ary_upfile = 0;

			$ary2_upfile[name][0] = $ary_upfile[name];
			$ary2_upfile[type][0] = $ary_upfile[type];
			$ary2_upfile[size][0] = $ary_upfile[size];
			$ary2_upfile[tmp_name][0] = $ary_upfile[tmp_name];

		} else {

			$this->is_ary_upfile = 1;

			$ary2_upfile = $ary_upfile;

		}

		foreach ($ary2_upfile[name] as $key => $value) {

			if ((! $ary2_upfile[name][$key]) or (! $ary2_upfile[size][$key])) {

				unset($ary2_upfile[name][$key]);
				unset($ary2_upfile[type][$key]);
				unset($ary2_upfile[size][$key]);
				unset($ary2_upfile[tmp_name][$key]);

			}

		}

		if ($ary2_upfile) {

			$this->upload_dir = $base_dir;
			$this->ary2_upfile = $ary2_upfile;

			return true;

		} else { return false; }

	}



	/*

	 εϷ  ̹  ȮѴ.

	 public boolean checkImg()
	 ex) checkImg()

	*/

	function checkImg() {

		foreach ($this->ary2_upfile[type] as $key => $upfile_type) {

			if (! strstr($upfile_type, "image/")) {

				$this->upload_error = ($key + 1) . "  ̹  ƴմϴ.";

				return false;

			}

		}

		return true;

	}



	/*

	 εϷ    뷮  ȮѴ.

	 public boolean checkSize(int max_filesize[, string mode])
	 ex) checkSize(3), checkSize(500, "kb")

	*/

	function checkSize($max_filesize, $mode = "mb") {

		switch ($mode) {

			case "mb":

				$max_filesize2 = $max_filesize * 1024 * 1024;

				break;

			case "kb":

				$max_filesize2 = $max_filesize * 1024;

				break;

			case "bytes":

				$max_filesize2 = $max_filesize;

				break;

			default:

				$this->report("ش 尡  ʽϴ. (Ŭ SonFSControl ޼ҵ checkSize)", "err");

				break;

		}

		foreach ($this->ary2_upfile[size] as $key => $upfile_size) {

			if ($upfile_size > $max_filesize2) {

				$this->upload_error = ($key + 1) . "   뷮 ʰϴ Դϴ.";

				return false;

			}

		}

		return true;

	}



	/*

	 εϷ  Ȯڰ õ ǿ ȿ ȮѴ.

	 public boolean checkExt(array ary_chk_ext[, string mode])
	 ex) checkExt(array("php", "inc")), checkExt(array("cgi", "txt"), "allow")

	*/

	function checkExt($ary_chk_ext, $mode = "deny") {

		switch ($mode) {

			case "deny":

				foreach ($this->ary2_upfile[name] as $key => $upfile_name) {

					$upfile_ext = strtolower(substr($upfile_name, (strrpos($upfile_name, ".") + 1)));

					if (in_array($upfile_ext, $ary_chk_ext)) {

						$this->upload_error = ($key + 1) . "  ε尡  ʴ Ȯڸ  Դϴ.";

						return false;

					}

				}

				return true;

				break;

			case "allow":

				foreach ($this->ary2_upfile[name] as $key => $upfile_name) {

					$upfile_ext = strtolower(substr($upfile_name, (strrpos($upfile_name, ".") + 1)));

					if (! in_array($upfile_ext, $ary_chk_ext)) {

						$this->upload_error = ($key + 1) . "  ε尡  ʴ Ȯڸ  Դϴ.";

						return false;

					}

				}

				return true;

				break;

			default:

				$this->report("ش 尡  ʽϴ. (Ŭ SonFSControl ޼ҵ checkExt)", "err");

				break;

		}

	}



	/*

	  εѴ.

	 public array upload()
	 ex) upload()

	*/

	function upload() {

		$ary_file_info = array();
		srand((double)microtime() * 1000000);

		foreach ($this->ary2_upfile[name] as $key => $value) {

			if ($this->ary2_upfile[name][$key] and $this->ary2_upfile[size][$key]) {

				if (strstr($this->ary2_upfile[type][$key], "text/") or ($this->ary2_upfile[name][$key] == "application/octet-stream")) $dst_filename = $this->ary2_upfile[name][$key] . date("ymdHis") . substr(md5(uniqid(rand())), 17, 3);
				else $dst_filename = date("ymdHis") . substr(md5(uniqid(rand())), 17, 3) . $this->ary2_upfile[name][$key];

				if (! move_uploaded_file($this->ary2_upfile[tmp_name][$key], $this->upload_dir . "/". $dst_filename)) {

					$this->upload_error = ($key + 1) . "  εϴµ Ͽϴ.";

					return $ary_file_info;

				} else {

					$ary_file_info[name][$key] = $dst_filename;
					$ary_file_info[type][$key] = $this->ary2_upfile[type][$key];
					$ary_file_info[size][$key] = $this->ary2_upfile[size][$key];

					if ($ary_img_size = @getimagesize($this->upload_dir . "/". $dst_filename)) {

						$ary_file_info[width][$key] = $ary_img_size[0];
						$ary_file_info[height][$key] = $ary_img_size[1];

					}

				}

			}

		}

		if (! $this->is_ary_upfile) {

			$ary_file_info[name] = $ary_file_info[name][0];
			$ary_file_info[type] = $ary_file_info[type][0];
			$ary_file_info[size] = $ary_file_info[size][0];

			if ($ary_file_info[width][0]) {

				$ary_file_info[width] = $ary_file_info[width][0];
				$ary_file_info[height] = $ary_file_info[height][0];

			}

		}

		return $ary_file_info;

	}



	/*

	 εϴ  ߻  Ѵ.

	 public string getUploadError()
	 ex) getUploadError()

	*/

	function getUploadError() {

		return $this->upload_error;

	}



	/*

	   ̸ Ѵ.

	 public string getRealFilename(string filename, string filetype)
	 ex) getRealFilename("test.txt", "text/html")

	*/

	function getRealFilename($filename, $filetype) {

		if (strstr($filetype, "text/") or ($filetype == "application/octet-stream")) return substr($filename, 0, -15);
		else return substr($filename, 15);

	}



	/*

	  ٿεѴ. ( EXPLORER ȭ)

	 public boolean download(string filepath, string filename, int filesize, string filetype)
	 ex) download("./test", "test.txt", 102400, "text/html")

	*/

	function download($filepath, $filename, $filesize, $filetype) {

		if ($GLOBALS[_SERVER]) $_SERVER =& $GLOBALS[_SERVER];
		else $_SERVER =& $GLOBALS[HTTP_SERVER_VARS];

		if (! is_file($filepath . "/" . $filename)) return false;
		elseif (strstr($filename, "../") or strstr($filename, "..%2F")) die("㰡  Դϴ.");

		if (preg_match("/(MSIE 5\.5|MSIE 6\.)/i", $_SERVER[HTTP_USER_AGENT])) {

			if (preg_match("/(MSIE 6\.)/i", $_SERVER[HTTP_USER_AGENT])) {

				$filename2 = (strstr($filetype, "text/") or ($filetype == "application/octet-stream")) ? substr($filename, 0, -15) : substr($filename, 15);

			} else {

				$filename2 = (strstr($filetype, "text/") or ($filetype == "application/octet-stream")) ? substr(urldecode($filename), 0, -15) : substr(urldecode($filename), 15);

			}

			header("Content-Type: doesn/matter");
			header("Content-Disposition: filename = $filename2");
			header("Content-Length: $filesize");
			header("Content-Transfer-Encoding: binary");
			header("Pragma: no-cache");
			header("Expires: 0");

		} else {

			$filename2 = (strstr($filetype, "text/") or ($filetype == "application/octet-stream")) ? substr(urldecode($filename), 0, -15) : substr(urldecode($filename), 15);

			header("Content-Type: file/unknown");
			header("Content-Disposition: attachment; filename = $filename2");
			header("Content-Length: $filesize");
			header("Pragma: no-cache");
			header("Expires: 0");

		}

		$fp = fopen($filepath . "/" . $filename, "rb");

		if (! $fp) {

			$this->report(" $filepath/${filename}() б  µ Ͽϴ.", "err");

			return false;

		}

		if (! fpassthru($fp)) {

			fclose($fp);

			return false;

		} else { return true; }

	}



	/*

	   ĽѴ.

	 public boolean parseConf(string conf_file[, boolean process sections])
	 ex) parseConf("./conf_test.php"), parseConf("./conf_test.php", true)

	*/

	function parseConf($conf_file, $process_sections = false) {

		if (! is_file($conf_file)) {

			$this->report("  ${conf_file}()  ʽϴ.", "err");

			return;

		}

		$aryConf = parse_ini_file($conf_file, $process_sections);

		if ($aryConf[encode_conf_item]) {

			$aryEncodeConfItem = preg_split("/\s*,\s*/", $aryConf[encode_conf_item]);

			foreach ($aryEncodeConfItem as $gEncodeConfItem) {

				$aryConf[$gEncodeConfItem] = base64_decode($aryConf[$gEncodeConfItem]);

			}

		}

		return $aryConf;

	}



	/*

	  Ǵ.

	 public boolean lock(string lock_file[, int more])
	 ex)lock("./test/test.txt"),  lock("./test/test.txt", 1)

	*/

	function lock($lock_file, $more = 0) {

		$this->more = $more;
		$this->lock_file = $lock_file;

		while ($this->exist($lock_file)) {

			sleep(1);
			$pass_time += 1;

			if ($pass_time >= $this->wait_time) $this->delete($lock_file);

		}

		$this->fp2 = fopen($lock_file, "w");

		if (! $this->fp2) {

			$this->report(" ${lock_file}()   µ Ͽϴ.", "err");

			return false;

		}

		if ($this->more) flock($this->fp2, 2);
		fwrite($this->fp2, date("Y-m-d H:i:s", time()));

		return true;

	}



	/*

	  Ѵ.

	 public boolean unlock()
	 ex) unlock()

	*/

	function unlock() {

		if ($this->mode) flock($this->fp2, 3);
		fclose($this->fp2);

		if (! $this->delete($this->lock_file)) return false;
		else return true;

	}



	/*

	 α׸ Ѵ.

	 private void report(string msg, string mode)
	 ex) report("  test.php()   µ Ͽϴ.", "err")

	*/

	function report($msg, $mode) {

		if (isset($GLOBALS[Log])) $GLOBALS[Log]->report($msg, $mode);

	}


}




/*--------------------------------------------------------------------

	Ŭ :: Guidance 1.0.0

	 :: 2002-04-21
	 :: 2003-03-26

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class Guidance {


	/*

	 ޼  Ѱܹ URL ̵Ѵ.

	 public void advice(string msg[, int|string location])
	 ex) advice("Error!!", -1), advice("Error!!"), advice("Error!!", "http://127.0.0.1")

	*/

	function advice($msg, $location = -1) {

		$msg = str_replace("\n", "\\n", "[ ȳ帳ϴ. ]\n\n" . $msg . "\n");

		echo ("

			<META http-equiv=content-type content='text/html; charset=ks_c_5601-1987'>
			<META http-equiv=expires content=0>

			<SCRIPT language='javascript'>
			<!--

			alert('$msg');

		");

		if (is_int($location)) echo("history.go($location);");
		else echo("window.location.replace('$location');");

		echo("

			//-->
			</SCRIPT>

		");

		exit;

	}



	/*

	 Ѱܹ URL ̵Ѵ.

	 public void locate(int|string location)
	 ex) locate(-1), locate("http://127.0.0.1")

	*/

	function locate($location) {

		echo ("

			<META http-equiv=content-type content='text/html; charset=ks_c_5601-1987'>
			<META http-equiv=expires content=0>

			<SCRIPT language='javascript'>
			<!--

		");

		if (is_int($location)) echo("history.go($location);");
		else echo("window.location.replace('$location');");

		echo("

			//-->
			</SCRIPT>

		");

		exit;

	}


}




/*--------------------------------------------------------------------

	Ŭ :: StopWatch 1.0.0

	 :: 2002-05-06
	 :: 2002-12-31

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class StopWatch {


	var $ary2_measure_info;


	/*

	 ġ Ѵ.

	 public void start([int no[, string subject]])
	 ex) start(), start(1, "Loading Time")

	*/

	function start($no = 0, $subject = "") {

		$this->ary2_measure_info[$no][subject] = $subject;

		$this->ary2_measure_info[$no][starttime] = microtime();

	}



	/*

	 ġ .

	 public void stop([int no])
	 ex) stop(1), stop(1)

	*/

	function stop($no = 0) {

		$this->ary2_measure_info[$no][stoptime] = microtime();

		$ary_start_time = explode(" ", $this->ary2_measure_info[$no][starttime]);
		$ary_stop_time = explode(" ", $this->ary2_measure_info[$no][stoptime]);

		$this->ary2_measure_info[$no][loadtime] = ($ary_stop_time[1] - $ary_start_time[1]) + ($ary_stop_time[0] - $ary_start_time[0]);

	}



	/*

	 ġ  ġ 籸Ͽ ȯѴ.

	 public void out([string type])
	 ex) out(), out("%02.3f")

	*/

	function out($type = "%02.3f") {

		$contents  = "\n\n        <!-----------------------------------------------------\n\n";
		$contents .= "		Ư  ð ġ  ~ !\n\n";

		foreach ($this->ary2_measure_info as $ary_measure_info) {

			$load_time = sprintf($type, $ary_measure_info[loadtime]);

			$contents .= "		" . ($ary_measure_info[subject] ? $ary_measure_info[subject] : " ó ð") . " :: " . $load_time . "\n";

		}

		$contents .= "\n";
		$contents .= "        ------------------------------------------------------>\n\n";

		flush();
		echo $contents;

	}


}




/*--------------------------------------------------------------------

	Ŭ :: ValueControl 1.0.0

	 :: 2002-04-27
	 :: 2002-11-27

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class ValueControl {


	/*

	 ش  ־ ڿ Ȥ ־  ϰ ִ üũѴ.

	 public boolean check(string check_str, string value[, int mode])
	 ex) check("/[A-Z]+/", "LOVE"), check("츮", "Ƹٿ 츮", 1)

	*/

	function check($check_str, $value, $mode = 2) {

		if ($mode == 1) {

			if (! strstr($value, $check_str)) return false;
			else return true;

		} elseif ($mode == 2) {

			if (! preg_match($check_str, $value)) return false;
			else return true;

		}

	}



	/*

	 ش  Ϻθ ־ ڿ üѴ.

	 public string replace(string part, string replace, string value[, int mode])
	 ex) replace("/[A-Z]+/", "LOVE", "POWER "), replace("", "", " ġ 츮 ", 1)

	*/

	function replace($part, $replace, $value, $mode = 2) {

		if ($mode == 1) return str_replace($part, $replace, $value);
		elseif ($mode == 2) return preg_replace($part, $replace, $value);

	}



	/*

	 ش  ־ ڷ иϿ 迭 ȯѴ.

	 public array split(string separator, string value[, int limit[, int mode]])
	 ex) split("\n", "LOVE\nPOWER"), split("\n", "LOVE\nPOWER\nRIGHT", 2, 2)

	*/

	function split($separator, $value, $limit = -1, $mode = 1) {

		if ($mode == 1) return explode($separator, $value);
		elseif ($mode == 2) return preg_split($separator, $value, $limit);

	}



	/*

	 ش 迭 ҵ ־ ڿ Ѵ.

	 public string join(array ary_source, string connect_element)
	 ex) join(array("LOVE", "POWER"), "\n")

	*/

	function join($ary_source, $connect_element) {

		return implode($ary_source, $connect_element);

	}



	/*

	 ش  ־ ̷ ߶󳽴.

	 public string cut(string value, int max_value_length[, string add_str])
	 ex) cut("ѹα  ѷϴ.", 17)

	*/

	function cut($value, $max_value_length, $add_str = "...") {

		if (strlen($value) <= $max_value_length) return $value;
		if (! (ord($value[$max_value_length - 1]) & 0x80)) return substr($value, 0, $max_value_length) . $add_str;

		$value_length = strlen($value);
		$two_byte_str = 0;

		for ($i = $max_value_length; $i < $value_length; $i++) {

			if (ord($value[$i]) & 0x80) $two_byte_str++;

		}

		if ($two_byte_str % 2) return substr($value, 0, $max_value_length - 1) . $add_str;
		else return substr($value, 0, $max_value_length) . $add_str;

	}



	/*

	 ش  Ϻθ ȯѴ.

	 public string extract(string value, int start[, int length])
	 ex) extract("ΰ ̶ ΰ?", 8, 1)

	*/

	function extract($value, $start, $length = 0) {

		return substr($value, $start, $length);

	}



	/*

	 ش  Ե 齽ø Ѵ.

	 public string|array stripSlashes(string|array mix_value)
	 ex) stripSlashes("\'\'̶ ܾ ΰ ǹ..")

	*/

	function stripSlashes($mix_value) {

		if (is_array($mix_value)) {

			$ary_value = "";

			foreach ($mix_value as $key => $value) {

				$ary_value[$key] = stripslashes($value);

			}

			return $ary_value;

		} else { return stripslashes($mix_value); }

	}



	/*

	 α׸ Ѵ.

	 private void report(string msg, string mode)
	 ex) report("  test.php()   µ Ͽϴ.", "err")

	*/

	function report($msg, $mode) {

		if (isset($GLOBALS[Log])) $GLOBALS[Log]->report($msg, $mode);

	}


}




/*--------------------------------------------------------------------

	Ŭ :: SonValueControl 1.0.0

	 :: 2002-06-08
	 :: 2003-05-20

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class SonValueControl extends ValueControl {


	/*

	 ش   ȮѴ.

	 public boolean isNull(string|array mix_value[, int all])
	 ex) isNull("Ƹٿ ߾"), isNull("Ƹٿ ߾", "", 1)

	*/

	function isNull($mix_value, $all = 0) {

		if (! is_array($mix_value)) $ary_value[0] = $mix_value;
		else $ary_value = $mix_value;

		$null_count = 0;

		foreach ($ary_value as $value) {

			$value2 = trim($value);

			if ($value2 == "") $null_count++;

		}

		if (($all == 1) and ($null_count == (count($ary_value) + 1))) return true;
		elseif (($all == 0) and $null_count) return true;
		else return false;

	}



	/*

	 ش  ־ 迭  ϳ ̻ ԵǾ ִ ȮѴ.

	 public boolean find(array ary_check_str, string value)
	 ex) find(array("ù", "ǲ"), "ù Ƹ.")

	*/

	function find($ary_check_str, $value) {

		foreach ($ary_check_str as $check_str) {

			if ($this->check(trim($check_str), $value, 1)) return true;

		}

		return false;

	}



	/*

	 ش  ־  ̳  ϰ ִ ȮѴ.

	 public boolean checkSpace(string value, int length)
	 ex) checkSpace("ùǲҼ.ֽǷ?", 50)

	*/

	function checkSpace($value, $length) {

		if ($this->check("/\S{" . ($length + 1) . ",}/", $value)) return false;
		return true;

	}



	/*

	 ش  ־ ǿ ° Ѵ.

	 public string beautifySize(int filesize[, int precision])
	 ex) beautifySize(512000), beautifySize(512002, 2)

	*/

	function beautifySize($filesize, $precision = 0) {

		if ($filesize > (1024 * 1024)) return round($filesize / (1024 * 1024), $precision) . "mb";
		elseif ($filesize > 1024) return round($filesize / 1024, $precision) . "kb";
		else return $filesize . "bytes";

	}



	/*

	 ش  Ե ּҸ ڵũѴ.

	 public string link(string value)
	 ex) link("http://127.0.0.1 ̵Ͻø..")

	*/

	function link($value) {

		$value2 = $this->replace("/(http|https|ftp):\/\/(([\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z-]*)+(\.[\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z.-]*)*(\.[0-9a-zA-Z]{1,4}))((\/[@~]*[\xA1-\xFE0-9a-zA-Z._-]+)([\xA1-\xFE0-9a-zA-Z.-\/?=&_]+[0-9a-zA-Z%]+)*)*/i", "<a href=$1://$2$6 target=_blank>$1://$2$6</a>", $value);
		$value3 = $this->replace("/([\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z._-]*)@(([\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z-]*)+\.([\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z.-]*)*(\.[0-9a-zA-Z]{1,4}))/", "<a href=mailto:$1@$2>$1@$2</a>", $value2);

		return $value3;

	}



	/*

	 ش  Ե ±׸ ȯѴ.

	 public string replaceTag(string value, array ary_tag, string mode)
	 ex) replaceTag("<A href='127.0.0.1'><FONT size=3>LOCALHOST</FONT></A>", array("a", "font")), replaceTag("<A href='127.0.0.1'><FONT size=3>LOCALHOST</FONT></A>", array("a", "font"), "deny")

	*/

	function replaceTag($value, $ary_tag, $mode = "allow") {

		switch ($mode) {

			case "allow":

				str_replace("<", "&lt;", $value);

				$pattern = "{&lt;(/*(" . $this->join($ary_tag, "|") . ")(\s+[\w\W]*?)*>)}mi";

				return preg_replace_callback($pattern, create_function('$ary_match', 'return "<" . $ary_match[1];'), $value);

				break;

			case "deny":

				$pattern = "{<(/*(" . $this->join($ary_tag, "|") . ")(\s+[\w\W]*?)*>)}mi";

				return preg_replace_callback($pattern, create_function('$ary_match', 'return "&lt;" . $ary_match[1]'), $value);

				break;

			default:

				$this->report("ش 尡  ʽϴ. (Ŭ SonValueControl ޼ҵ replaceTag)", "err");

				break;

		}

	}



	/*

	 ش  ̸ ּ ȮѴ.

	 public boolean isEmail(string value)
	 ex) isEmail("test@127.0.0.1")

	*/

	function isEmail($value) {

		if (! $this->check("/[\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z._-]*@([\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z-]*)+(\.[\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z.-]*)*(\.[0-9a-zA-Z]{1,4})/", $value)) return false;
		else return true;

	}



	/*

	 ش  Ȩ ּ ȮѴ.

	 public boolean isHomepage(string value)
	 ex) isHomepage("http://127.0.0.1")

	*/

	function isHomepage($value) {

		if (! $this->check("/(http|https|ftp):\/\/(([\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z-]*)+(\.[\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z.-]*)*(\.[0-9a-zA-Z]{1,4}))((\/[@~]*[\xA1-\xFE0-9a-zA-Z._-]+)([\xA1-\xFE0-9a-zA-Z.-\/?=&_]+[0-9a-zA-Z%]+)*)*/i", $value)) return false;
		else return true;

	}



	/*

	 ش  URL ȮѴ.

	 public boolean isURL(string value)
	 ex) isURL("http://127.0.0.1/test/test.txt")

	*/

	function isURL($value) {

		if (! $this->check("/(http|https|ftp):\/\/(([\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z-]*)+(\.[\xA1-\xFE0-9a-zA-Z][\xA1-\xFE0-9a-zA-Z.-]*)*(\.[0-9a-zA-Z]{1,4}))((\/[@~]*[\xA1-\xFE0-9a-zA-Z._-]+)([\xA1-\xFE0-9a-zA-Z.-\/?=&_]+[0-9a-zA-Z%]+)*)*/i", $value)) return false;
		else return true;

	}



	/*

	 ش  ĺ ȮѴ.

	 public boolean isAlpha(string value)
	 ex) isAlpha("test")

	*/

	function isAlpha($value) {

		if (! $this->check("/^[a-zA-Z]+$/", $value)) return false;
		else return true;

	}



	/*

	 ش   ȮѴ.

	 public boolean isNum(string value)
	 ex) isNum("24")

	*/

	function isNum($value) {

		if (! $this->check("/^[0-9]+$/", $value)) return false;
		else return true;

	}



	/*

	 ش  ĺ,  Ȥ   ȮѴ.

	 public boolean isAlnum(string value)
	 ex) isAlnum("24test")

	*/

	function isAlnum($value) {

		if (! $this->check("/^[0-9a-zA-Z]+$/", $value)) return false;
		else return true;

	}



	/*

	 ش  ùٸ  ȮѴ.

	 public boolean isBirthday(int year, int month, int day)
	 ex) isBirthday(1982, 7, 2)

	*/

	function isBirthday($year, $month, $day) {

		if (! checkdate($month, $day, ($year > date("Y")) ? 0 : $year)) return false;
		else return true;

	}



	/*

	 ش  ùٸ ֹεϹȣ ȮѴ.

	 public boolean isResno(int resno1, int resno2)
	 ex) isResno(19820702, 7777777)

	*/

	function isResno($resno1, $resno2) {

		if (! checkdate((int)substr($resno1, 2, 2), (int)substr($resno1, 4, 2), (int)substr($resno1, 0, 2))) return false;

		$resno = $resno1 . $resno2;

		if (strlen($resno) != 13) return false;

		$ary_times_num = array(2, 3, 4, 5, 6, 7, 8, 9, 2, 3, 4, 5);
		$compare_no = 0;

		for ($i = 0; $i < 12; $i++) {

			$compare_num += $ary_times_num[$i] * substr($resno, $i, 1);

		}

		if (((11 - ($compare_num % 11)) % 10) != substr($resno, 12, 1)) return false;

		return true;

	}



	/*

	 ش  ùٸ ȣ ȮѴ.

	 public boolean isZipcode(string zipcode1, string zipcode2)
	 ex) isZipcode("000", "0000")

	*/

	function isZipcode($zipcode1, $zipcode2) {

		$zipcode = $zipcode1 . $zipcode2;

		if (strlen($zipcode) != 6 or (int)$zipcode != 6) return false;
		else return true;

	}



	/*

	 ش  ùٸ ȭȣ ȮѴ.

	 public boolean isTelephone(string telephone1, string telephone2, string telephone3)
	 ex) isTelephone("273", "234, "234")

	*/

	function isTelephone($telephone1, $telephone2, $telephone3) {

		$ary_area_num = array("02", "031", "032", "033", "041", "042", "043", "051", "052", "053", "054", "055", "061", "062", "063", "064");
		$area_num_check = false;

		for ($i = 0; $i < 16; $i++) {

			if ($ary_area_num[$i] == $telephone1) {

				$area_num_check = true;

				break;

			}

		}

		if (! $area_num_check) return false;
		elseif ((strlen($telephone2) < 3 || strlen($telephone2) > 4) || (strlen($telephone3) != 4)) return false;

		return true;

	}



	/*

	 ش  ùٸ ڵ ȣ ȮѴ.

	 public boolean isCellphone(string cellphone1, string cellphone2, string cellphone3)
	 ex) isCellphone("273", "234, "234")

	*/

	function isCellphone($cellphone1, $cellphone2, $cellphone3) {

		$ary_office_num = array("010", "011", "016", "017", "018", "019");
		$office_num_check = false;

		for ($i = 0; $i < 6; $i++) {

			if ($ary_office_num[$i] == $cellphone1) {

				$office_num_check = true;

				break;

			}

		}

		if (! $office_num_check) return false;
		elseif ((strlen($cellphone2) < 3 || strlen($cellphone2) > 4) || (strlen($cellphone3) != 4)) return false;

		return true;

	}


}




/*--------------------------------------------------------------------

	Ŭ :: Graphic 1.0.0

	 :: 2002-08-12
	 :: 2002-12-02

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class Graphic {


	var $inc_str = "Thumbnail";


	/*

	 ̹ ,  ũ⸦ 迭 Ѵ.

	 public array getSize(string filename)
	 ex) getSize("./test/test.gif")

	*/

	function getSize($filename) {

		if (! is_file($filename)) $this->report(" ${filename}()  ʽϴ.", "err");

		return getimagesize($filename);

	}



	/*

	 ־ X    ̹ Y  ȯѴ.

	 public int getYSize(int src_x_size, int src_y_size, int dst_x_size)
	 ex) getYSize(600, 300, 500)

	*/

	function getYSize($src_x_size, $src_y_size, $dst_x_size) {

		return ($src_y_size * $dst_x_size) / $src_x_size;

	}



	/*

	  ̹ Ѵ.

	 private int loadOriginal(string filename)
	 ex) loadOriginal("./test/test.gif")

	*/

	function loadOriginal($filename) {

		$fp = fopen($filename, "r");
		if (! $fp) $this->report(" ${filename}() б  µ Ͽϴ.", "err");
		$contents = fread($fp, filesize($filename));
		fclose($fp);

		$ary_img_info = $this->getSize($filename);

		switch ($ary_img_info[2]) {

			case 1:

				$im = imagecreatefromgif($contents);

				break;

			case 2:

				$im = imagecreatefromjpeg($contents);

				break;

			case 3:

				$im = imagecreatefrompng($contents);

				break;

		}

		if (! $im) {

			$im = imagecreate($ary_img_info[0], $ary_img_info[1]);
			$bg_color = imagecolorallocate($im, 255, 255, 255);
			$text_color = imagecolorallocate($im, 0, 0, 0);
			imagefilledrectangle($im, 0, 0, $ary_img_info[0], $ary_img_info[1], $bg_color);
			imagestring($im, 2, 5, 5, $this->inc_str, $text_color);
			imagecolortransparent($im, $bg_color);

		}

		return $im;

	}



	/*

	  ̹ Ѵ.

	 private int loadThumb(string src_filename, int dst_x_size, int dst_y_size)
	 ex) loadThumb("./test/test.gif", 100, 70)

	*/

	function loadThumb($src_filename, $dst_x_size, $dst_y_size) {

		$src_im = $this->loadOriginal($src_filename);

		$ary_img_info = $this->getSize($src_filename);
		$src_x_size = $ary_img_info[0];
		$src_y_size = $ary_img_info[1];

		if (($dst_x_size / $src_x_size) > ($dst_y_size / $src_y_size)) {

			$src_x_size2 = $src_x_size;
			$src_y_size2 = round(($src_x_size * $dst_y_size) / $dst_x_size);
			$src_x_point = 0;
			$src_y_point = $src_y_size - round(($src_y_size - $src_y_size2) / 2);

		} else {

			$src_x_size2 = round(($src_y_size * $dst_x_size) / $dst_y_size);
			$src_y_size2 = $src_y_size;
			$src_x_point = $src_x_size - round(($src_x_size - $src_x_size2) / 2);
			$src_y_point = 0;

		}

		$dst_im = imagecreate($dst_x_szie, $dst_y_size);
		imagecopyresized($dst_im, $src_im, 0, 0, $src_x_point, $src_y_point, $dst_x_size, $dst_y_size, $src_x_size2, $src_y_size2);

		imagedestroy($src_im);

		return $dst_im;

	}



	/*

	  ̹ Ѵ.

	 public boolean createThumb(string src_filename, string dst_filename, int dst_x_size, int dst_y_size)
	 ex) createThumb("./test/test.gif", "./test/thumb/thumb_test.gif", 100, 70)

	*/

	function createThumb($src_filename, $dst_filename, $dst_x_size, $dst_y_size) {

		if (! function_exists("imagecreate")) $this->report("GD ̺귯  Լ   ϴ.", "err");
		elseif (! is_file($src_filename)) $this->report(" ${src_filename}()  ʽϴ.", "err");

		$dst_im = $this->loadThumb($src_filename, $dst_x_size, $dst_y_size);

		if ($ary_img_info[2] == 1) imagegif($dst_im, $dst_filename);
		elseif ($ary_img_info[2] == 2) imagejpeg($dst_im, $dst_filename);
		elseif ($ary_img_info[2] == 3) imagepng($dst_im, $dst_filename);
		else imagegif($dst_im, $dst_filename);

		imagedestroy($dst_im);

		if (! is_file($dst_filename)) return false;
		return true;

	}



	/*

	 α׸ Ѵ.

	 private void report(string msg, string mode)
	 ex) report("  test.php()   µ Ͽϴ.", "err")

	*/

	function report($msg, $mode) {

		if (isset($GLOBALS[Log])) $GLOBALS[Log]->report($msg, $mode);

	}


}




/*--------------------------------------------------------------------

	Ŭ :: Mail 1.0.0

	 :: 2002-07-15
	 :: 2002-12-02

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class Mail {


	var $contents_charset = "euc-kr";
	var $ary2_part;
	var $headers;
	var $body;


	/*

	 õ  迭 Ʈ ҷ Ѵ.

	 public void putAttachment(string contents, string name, string type, string encode)
	 ex) putAttachment("ϼ. ݰϴ.", "", "text/plain", "8bit")

	*/

	function putAttachment($contents, $name, $type, $encode) {

		$this->ary2_part[] = array(

			"name"			=>	$name,
			"type"			=>	$type,
			"encode"		=>	$encode,
			"contents"		=>	$contents

		);

	}



	/*

	  忡 ° , óѴ.

	 public boolean putContents(string contents, int mode)
	 ex) putContents("ȳϼ. ݰϴ.", "h-th")

	*/

	function putContents($contents, $mode) {

		switch ($mode) {

			case "p":

				$this->putAttachment($contents, "", $type = "text/plain", $encode = "base64");

				return true;

			case "h-ot":

				$this->putAttachment(nl2br(htmlspecialchars($contents)), "", $type = "text/html", $encode = "base64");

				return true;

			case "h-th":

				$this->putAttachment(nl2br($contents), "", $type = "text/html", $encode = "base64");

				return true;

			case "h-oh":

				$this->putAttachment($contents, "", $type = "text/html", $encode = "base64");

				return true;

			default:

				$this->report("ش 尡  ʽϴ. (Ŭ Mail ޼ҵ putAttachment)", "err");

				return false;

		}

	}



	/*

	  , óѴ.

	 public boolean putFile(string put_file)
	 ex) putFile($put_file)

	*/

	function putFile($put_file) {

		$fp = fopen($put_file, "r");

		if (! $fp) {

			$this->report(" ${put_file}() б  µ Ͽϴ.", "err");

			return false;

		}

		$contents = fread($fp, $put_file_size);
		fclose($fp);

		$this->putAttachment(preg_replace("/(.{80})/", "\1\r\n", base64_encode($contents)), basename($put_file_name), $type = ($put_file_type ? $put_file_type : "application/octet-stream"), $encode = "base64");

		return true;

	}



	/*

	 Ʈ ϼѴ.

	 private string buildPart(int index)
	 ex) buildPart(2)

	*/

	function buildPart($index) {

		$part  = "Content-type: " . $this->ary2_part[$index][type] . ";" . (preg_match("/(text)/i", $this->ary2_part[$index][type]) ? " charset=\"$this->contents_charset\"" : "") . ($this->ary2_part[$index][name] ? " name=\"" . $this->ary2_part[$index][name] . "\"" : "") . "\r\n";
		$part .= "Content-Transfer-encoding: " . $this->ary2_part[$index][encode] . "\r\n\r\n";
		$part .= chunk_split(($this->ary2_part[$index][encode] == "base64") ? base64_encode($this->ary2_part[$index][contents]) : $this->ary2_part[$index][contents]) . "\r\n\r\n";

		return $part;

	}



	/*

	 ƼƮ ϼѴ.

	 private void buildMultipart()
	 ex) buildMultipart()

	*/

	function buildMultipart() {

		$boundary = "----ozone" . md5(uniqid(time()));

		$this->headers  = "Content-Type: multipart/mixed; boundary=\"" . $boundary . "\"\r\n\r\n";
		$this->body .= "This is a multi-part message in MIME format.\r\n\r\n";
		$this->body .= "--" . $boundary . "\r\n";

		foreach ($this->ary2_part as $key => $ary_value) {

			$this->body .= $this->buildPart($key);
			$this->body .= "--" . $boundary . "\r\n";

		}

	}



	/*

	  .

	 public boolean send(string from_name, string from_email, string to_email, string subject)
	 ex) send("test", "test@127.0.0.1", "test2@127.0.0.1", "   ?")

	*/

	function send($from_name, $from_email, $to_email, $subject) {

		$from = $from_name ? $from_name . "<" . $from_email . ">" : $from_email;

		$headers  = "Return-Path: $from\r\n";
		$headers .= "From: $from\r\n";
		$headers .= "X-Mailer: OZONE Mailer\r\n";
		$headers .= "MIME-Version: 1.0\r\n";

		$this->buildMultipart();

		if (! mail($to_email, $subject, $this->body, $headers . $this->headers)) return false;
		return true;

	}



	/*

	 α׸ Ѵ.

	 private void report(string msg, string mode)
	 ex) report("  test.php()   µ Ͽϴ.", "err")

	*/

	function report($msg, $mode) {

		if (isset($GLOBALS[Log])) $GLOBALS[Log]->report($msg, $mode);

	}


}




/*--------------------------------------------------------------------

	Ŭ :: Auth 1.0.0

	 :: 2002-05-18
	 :: 2003-03-27

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class Auth {


	var $auth_dir;
	var $auth_id;
	var $auth_result;


	/*

	  (Constructor) Ѵ.

	 void Auth(string auth_base_dir)
	 Constructor!!
	 ex) Auth("./test")

	*/

	function Auth($auth_base_dir = ".") {

		if ($GLOBALS[_COOKIE]) $_COOKIE =& $GLOBALS[_COOKIE];
		else $_COOKIE =& $GLOBALS[HTTP_COOKIE_VARS];

		if (! is_dir($auth_base_dir . "/auth")) {

			if (! mkdir($auth_base_dir . "/auth", 0777)) $this->report("  $auth_base_dir/auth() ϴµ Ͽϴ.", "err");

		}

		chmod($auth_base_dir . "/auth", 0777);

		$this->auth_dir = $auth_base_dir . "/auth";

		if ($_COOKIE[id]) $this->auth_id = $_COOKIE[id];

	}



	/*

	 ش ̵ αѴ.

	 public boolean login(string auth_id, string ary_auth_id_info, string ary_login_info, int max_request_gap)
	 ex) login("test", array("pass" => "test"), array("pass" => "test"), 3600)

	*/

	function login($auth_id, $ary_auth_id_info, $ary_login_info, $max_request_gap = 1200) {

		if ($GLOBALS[_SERVER]) $_SERVER =& $GLOBALS[_SERVER];
		else $_SERVER =& $GLOBALS[HTTP_SERVER_VARS];

		$this->auth_id = $auth_id;

		if (headers_sent()) {

			$this->report(" ̹ ۵Ǿ αο Ͽϴ.", "err");

			return false;

		}

		foreach ($ary_login_info as $key => $value) {

			if (strcmp($ary_auth_id_info[$key], $value)) {

				$this->auth_result = 0;

				break;

			}

		}

		if ($this->auth_result !== 0) $this->auth_result = 1;

		if ($this->auth_result) {

			if (file_exists($this->auth_dir . "/auth_" . $this->auth_id . ".php")) {

				$this->report($this->auth_id . "\tα ", "acs");

				$this->logout();

				return false;

			}

			srand((double)microtime() * 1000000);

			$main_sid = md5(uniqid(rand()));
			$sub_sid = md5(uniqid(rand()));

			$contents  = "\n\n";
			$contents .= "/*  ̵     _________________*/\n\n";
			$contents .= "main_sid = " . $main_sid . "\n";
			$contents .= "sub_sid = " . $sub_sid . "\n";
			$contents .= "login_time = " . time() . "\n";
			$contents .= "browser = " . $_SERVER[HTTP_USER_AGENT] . "\n";
			$contents .= "ip = " . $_SERVER[REMOTE_ADDR] . "\n";
			$contents .= "max_request_gap = " . $max_request_gap . "\n\n";

			$fp = fopen($this->auth_dir . "/auth_" . $this->auth_id . ".php", "w");

			if (! $fp) {

				$this->report("  $this->auth_dir/auth_$this->auth_id.php()   µ Ͽϴ.", "err");

				return false;

			}

			fwrite($fp, $contents);
			fclose($fp);

			setcookie("current_time", time(), 0);
			setcookie("id", $this->auth_id, 0);
			setcookie("main_sid", $main_sid, 0);
			setcookie("sub_sid", $sub_sid, 0);

			$this->report($this->auth_id . "\tα ", "acs");

			return true;

		} else {

			$this->report($this->auth_id . "\tα ", "acs");

			return false;

		}

	}



	/*

	 ش ̵ αεǾ ִ ȮѴ.

	 public boolean confirm()
	 ex) confirm()

	*/

	function confirm() {

		global $_SESSION;

		if ($GLOBALS[_COOKIE]) $_COOKIE =& $GLOBALS[_COOKIE];
		else $_COOKIE =& $GLOBALS[HTTP_COOKIE_VARS];
		if ($GLOBALS[_SERVER]) $_SERVER =& $GLOBALS[_SERVER];
		else $_SERVER =& $GLOBALS[HTTP_SERVER_VARS];

		if (headers_sent()) {

			$this->report(" ̹ ۵Ǿ α Ȯο Ͽϴ.", "err");

			return false;

		}

		if (! is_file($this->auth_dir . "/auth_" . $this->auth_id . ".php")) {

			$this->report($this->auth_id . "\tα Ȯ ", "acs");

			return false;

		}

		$ary_session_info = file($this->auth_dir . "/auth_" . $this->auth_id . ".php");

		foreach ($ary_session_info as $session_info) {

			$ary_session = preg_split("/\s*=\s*/", chop($session_info), 2);

			$_SESSION[$ary_session[0]] = (is_array(unserialize($ary_session[1]))) ? unserialize($ary_session[1]) : $ary_session[1];

		}

		if ((time() - $_COOKIE[current_time]) > $_SESSION[max_request_gap]) {

			$this->logout();

			$this->report($this->auth_id . "\tðʰ  α׾ƿ", "acs");

			return false;

		} elseif (strcmp($_SESSION[main_sid], $_COOKIE[main_sid]) or strcmp($_SESSION[sub_sid], $_COOKIE[sub_sid]) or strcmp($_SESSION[browser], $_SERVER[HTTP_USER_AGENT]) or strcmp($_SESSION[ip], $_SERVER[REMOTE_ADDR])) {

			$this->logout();

			$this->report($this->auth_id . "\tα Ȯ ", "acs");

			return false;

		}

		setcookie("current_time", time(), 0);

		return true;

	}



	/*

	 ش ̵ α׾ƿ óѴ.

	 public boolean logout([string auth_id])
	 ex) logout(), logout("test")

	*/

	function logout($auth_id = "") {

		if ($GLOBALS[_COOKIE]) $_COOKIE =& $GLOBALS[_COOKIE];
		else $_COOKIE =& $GLOBALS[HTTP_COOKIE_VARS];

		if ($auth_id) $this->auth_id = $auth_id;

		if (headers_sent()) {

			$this->report(" ̹ ۵Ǿ α׾ƿ Ͽϴ.", "err");

			return false;

		}

		if (! unlink($this->auth_dir . "/auth_" . $this->auth_id . ".php")) {

			$this->report($this->auth_id . "\tα׾ƿ ", "acs");

			return false;

		}

		setcookie("current_time");
		setcookie("id");
		setcookie("main_sid");
		setcookie("sub_sid");

		$this->report($this->auth_id . "\tα׾ƿ ", "acs");

		return true;

	}



	/*

	 Ǻ ,  Ȥ Ѵ.

	 public boolean adjustSess(string var_name, string mode)
	 ex) adjustSess("id", "reg")

	*/

	function adjustSess($var_name, $mode) {

		if ($GLOBALS[_COOKIE]) $_COOKIE =& $GLOBALS[_COOKIE];
		else $_COOKIE =& $GLOBALS[HTTP_COOKIE_VARS];

		$fp = fopen($this->auth_dir . "/auth_" . $this->auth_id . ".php", "r");

		if (! $fp) {

			$this->report("  $this->auth_dir/auth_$this->auth_id.php() б  µ Ͽϴ.", "err");

			return false;

		}

		$contents = fread($fp, 10240);
		fclose($fp);

		$var_value = (is_array($GLOBALS[$var_name])) ? serialize($GLOBALS[$var_name]) : $GLOBALS[$var_name];

		switch ($mode) {

			case "reg":

				$contents2 = $contents . $var_name . " = " . $var_value . "\n";

				break;

			case "mod":

				$contents2 = preg_replace("/($var_name){1}\s*=\s*.+?\n/i", $var_name . " = " . $var_value . "\n", $contents);

				break;

			case "del":

				$contents2 = preg_replace("/($var_name){1}\s*=\s*.+?\n/i", "", $contents);

				break;

			default:

				$this->report("ش 尡  ʽϴ. (Ŭ Auth ޼ҵ adjustSess)", "err");

				return false;

		}

		$fp = fopen($this->auth_dir . "/auth_" . $this->auth_id . ".php", "w");

		if (! $fp) {

			$this->report("  $this->auth_dir/auth_$this->auth_id.php()   µ Ͽϴ.", "err");

			return false;

		}

		fwrite($fp, $contents2);
		fclose($fp);

		return true;

	}



	/*

	 α׸ Ѵ.

	 private void report(string msg, string mode)
	 ex) report("  test.php()   µ Ͽϴ.", "err")

	*/

	function report($msg, $mode) {

		if (isset($GLOBALS[Log])) $GLOBALS[Log]->report($msg, $mode);

	}


}




/*--------------------------------------------------------------------

	Ŭ :: Log 1.0.0

	 :: 2002-10-13
	 :: 2002-12-03

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class Log {


	var $access_report;
	var $error_report;
	var $access_log_file;
	var $error_log_file;


	/*

	  (Constructor) Ѵ.

	 void Log(int access_report, int error_report, string log_base_dir)
	 Constructor!!
	 ex) Log(1, 0, "./test")

	*/

	function Log($access_report = 0, $error_report = 0, $log_base_dir = ".") {

		if ($access_report or $error_report) {

			if (! is_dir($log_base_dir . "/log")) {

				if (! mkdir($log_base_dir . "/log", 0777)) die("α    ϴ.");

			}

			if ($access_report) $this->access_log_file = $log_base_dir . "/log/log_access.php";
			if ($error_report) $this->error_log_file = $log_base_dir . "/log/log_error.php";

		}

		$this->access_report = $access_report;
		$this->error_report = $error_report;

	}



	/*

	 α׸ Ѵ.

	 public void report(string msg, string mode)
	 ex) report("  test.php()   µ Ͽϴ.", "err")

	*/

	function report($msg, $mode) {

		if ($GLOBALS[_SERVER]) $_SERVER =& $GLOBALS[_SERVER];
		else $_SERVER =& $GLOBALS[HTTP_SERVER_VARS];

		if ($mode != "acs" and $mode != "err") die("α  ${mode}  ʴ Դϴ.");

		if ($this->access_report and ($mode == "acs")) {

			$contents = date("Y-m-d H:i:s", time()) . "\t" . $msg . "\t" . $_SERVER[REMOTE_ADDR] . "\t" . $_SERVER[HTTP_USER_AGENT] . "\n";

			$fp = fopen($this->access_log_file, "a");

			if (! $fp) die(" α׸   ϴ.");

			fwrite($fp, $contents);
			fclose($fp);

		} elseif ($this->error_report and ($mode == "err")) {

			$contents = date("Y-m-d H:i:s", time()) . "\t" . $_SERVER[HTTP_HOST] . "\t" . basename($_SERVER[SCRIPT_NAME]) . "\t" . $msg . "\n";

			$fp = fopen($this->error_log_file, "a");

			if (! $fp) die(" α׸   ϴ.");

			fwrite($fp, $contents);
			fclose($fp);

		}

	}


}




/*--------------------------------------------------------------------

	Ŭ :: ProgUtil 1.0.0

	 :: 2002-08-09
	 :: 2003-03-31

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class ProgUtil {


	var $page_key;
	var $prev_str;
	var $next_str;
	var $last_str;
	var $extent_key;
	var $find_extent_gap;
	var $prev_find_str;
	var $next_find_str;

	var $now_page;
	var $total_page;
	var $first_page;
	var $end_page;
	var $prev_block_end_page;
	var $next_block_first_page;
	var $now_extent;
	var $first_extent;
	var $end_extent;


	/*

	 ¡ϱ   ʱȭѴ.

	 public boolean basePaging([string page_key[, string perv_str[, string next_str[, string last_str[, string extent_key[, int find_extent_gap[, string prev_find_str, [sting next_find_str]]]]]]]]])
	 ex) basePaging(), basePaging("piece", "<img src=prev.gif border=0>", "<img src=next.gif border=0>", "<img src=last.gif boarder=0>", "scope", 3, "<img src=prev_find.gif border=0>", "<img src=next_find.gif border=0>")

	*/

	function basePaging($page_key = "page", $prev_str = "PREV", $next_str = "NEXT", $last_str = "LAST", $extent_key = "extent", $find_extent_gap = -2, $prev_find_str = "PREV FIND", $next_find_str = "NEXT FIND") {

		$this->page_key = $page_key;
		$this->extent_sums_trait = $extent_sums_trait;
		$this->prev_str = $prev_str;
		$this->next_str = $next_str;
		$this->last_str = $last_str;
		$this->extent_key = $extent_key;
		$this->find_extent_gap = $find_extent_gap;
		$this->prev_find_str = $prev_find_str;
		$this->next_find_str = $next_find_str;

	}



	/*

	  ̵  ϱ   Ѵ.

	 private void setPagingInfo(int now_page, int total_article, int num_per_page, int page_per_block[, int now_extent[, int first_extent[, end_extent]]])
	 ex) setPagingInfo(2, 24, 10, 10), setPagerInfo(2, 24, 10, 10, 2, 1, 8)

	*/

	function setPagingInfo($now_page, $total_article, $num_per_page, $page_per_block, $now_extent = 0, $first_extent = 0, $end_extent = 0) {

		$this->now_page = $now_page;

		$this->total_page = $total_article ? ceil($total_article / $num_per_page) : 1;
		$total_block = ceil($this->total_page / $page_per_block);
		$now_block = ceil($this->now_page / $page_per_block);

		$this->first_page = (($now_block - 1) * $page_per_block) + 1;
		$this->end_page = ($total_block > $now_block) ? ($now_block * $page_per_block) : $this->total_page;

		$this->prev_block_end_page = $this->first_page - 1;
		$this->next_block_first_page = $this->end_page + 1;

		$this->now_extent = $now_extent;
		$this->first_extent = $first_extent;
		$this->end_extent = $end_extent;

	}



	/*

	  ̵  Ѵ. (BAR )

	 public string getPageBar(string base_link[, string add_link])
	 ex) getPageBar("./list.php?code=test"), getPageBar("./list.php?code=test", "&extent=2")

	*/

	function getPageBar($base_link, $add_link = "") {

		$page_bar = "";

		if ($this->now_extent and (abs($this->now_extent) > abs($this->first_extent))) $page_bar .= "<a href=" . $base_link . "&" . $this->extent_key . "=" . ($this->now_extent - $this->find_extent_gap) . "&" . $this->page_key . "=1" . $add_link . ">" . $this->prev_find_str . "</a> ";
		if ($this->prev_block_end_page) $page_bar .= "<a href=" . $base_link . "&" . $this->extent_key . "=" . $this->now_extent . "&" . $this->page_key . "=" . $this->prev_block_end_page . $add_link . ">" . $this->prev_str . "</a> ";

		for ($i = $this->first_page; $i <= $this->end_page; $i++) {

			$page_bar .= ($i == $this->now_page) ? "<b>" . $i . "</b> " : "<a href=" . $base_link . "&" . $this->extent_key . "=" . $this->now_extent . "&" . $this->page_key . "=" . $i . $add_link . ">" . $i . "</a> ";

		}

		if ($this->next_block_first_page <= $this->total_page) $page_bar .= "<a href=" . $base_link . "&" . $this->extent_key . "=" . $this->now_extent . "&" . $this->page_key . "=" . $this->next_block_first_page . $add_link . ">" . $this->next_str . "</a> ";
		if ($this->now_page < $this->total_page) $page_bar .= "<a href=" . $base_link . "&" . $this->extent_key . "=" . $this->now_extent . "&" . $this->page_key . "=" . $this->total_page . $add_link . ">" . $this->last_str . "</a>";
		if ($this->now_extent and (abs($this->now_extent + $this->find_extent_gap) < abs($this->end_extent))) $page_bar .= "<a href=" . $base_link . "&" . $this->extent_key . "=" . ($this->now_extent + $this->find_extent_gap) . "&" . $this->page_key . "=1" . $add_link . ">" . $this->next_find_str . "</a>";

		return $page_bar;

	}



	/*

	  ̵  Ѵ. (SELECT )

	 public string getPageSelect(string base_link[, string add_link[, select_name[, int fix]]])
	 ex) getPageSelect("./list.php?code=test"), getPageSelect("./list.php?code=test", "&extent=2", "go_page", 1)

	*/

	function getPageSelect($base_link, $add_link = "", $select_name = "page", $fix = 0) {

		if ($fix) $page_select = "<SELECT name=$select_name onChange='javascript: document.all.get_list.src = this.options[this.selectedIndex].value'>";
		else $page_select = "<SELECT name=$select_name onChange='javascript: window.location.replace(this.options[this.selectedIndex].value)'>";

		if ($this->now_extent and (abs($this->now_extent) > abs($this->first_extent))) $page_select .= "<OPTION value=" . $base_link . "&" . $this->extent_key . "=" . ($this->now_extent - $this->find_extent_gap) . "&" . $this->page_key . "=1" . $add_link . ">" . $this->prev_find_str . "</OPTION> ";
		if ($this->prev_block_end_page) $page_select .= "<OPTION value=" . $base_link . "&" . $this->extent_key . "=" . $this->now_extent . "&" . $this->page_key . "=" . $this->prev_block_end_page . $add_link . ">" . $this->prev_str . "</OPTION> ";

		for ($i = $this->first_page; $i <= $this->end_page; $i++) {

			$page_select .= (($fix == 0) and ($i == $this->now_page)) ? "<OPTiON selected>" . $i . "</OPTION>" : "<OPTION value=" . $base_link . "&" . $this->extent_key . "=" . $this->now_extent . "&" . $this->page_key . "=" . $i . $add_link . ">" . $i . "</OPTION>";

		}

		if ($this->next_block_first_page <= $this->total_page) $page_select .= " <OPTION value=" . $base_link . "&" . $this->extent_key . "=" . $this->now_extent . "&" . $this->page_key . "=" . $this->next_block_first_page . $add_link . ">" . $this->next_str . "</OPTION>";
		if ($this->now_page < $this->total_page) $page_select .= " <OPTION value=" . $base_link . "&" . $this->extent_key . "=" . $this->now_extent . "&" . $this->page_key . "=" . $this->total_page . $add_link . ">" . $this->last_str . "</OPTION>";
		if ($this->now_extent and (abs($this->now_extent + $this->find_extent_gap) < abs($this->end_extent))) $page_select .= " <OPTION value=" . $base_link . "&" . $this->extent_key . "=" . ($this->now_extent + $this->find_extent_gap) . "&" . $this->page_key . "=1" . $add_link . ">" . $this->next_find_str . "</OPTION>";

		$page_select .= "</SELECT>";
		if ($fix) $page_select .= "<SCRIPT language=javascript id=get_list></SCRIPT>";

		return $page_select;

	}



	/*

	 ü  Ѵ.

	 public int getTotalPage()
	 ex) getTotalPage()

	*/

	function getTotalPage() {

		return $this->total_page;

	}



	/*

	   Ѵ.

	 public int getPrevPage()
	 ex) getPrevPage()

	*/

	function getPrevPage() {

		return ($this->now_page > 1) ? $this->now_page - 1 : null;

	}



	/*

	   Ѵ.

	 public int getNextPage()
	 ex) getNextPage()

	*/

	function getNextPage() {

		return ($this->now_page < $this->total_page) ? $this->now_page + 1 : null;

	}


}




/*--------------------------------------------------------------------

	Ŭ :: Template 1.0.0

	 :: 2002-12-29
	 :: 2003-08-10

	Copyright OZONEBOARD.COM. All rights reserved.

--------------------------------------------------------------------*/

class Template {


	var $_template_dir			= null;
	var $_compile_dir			= null;
	var $_template_file			= null;
	var $_compile_file			= null;

	var $_ary_conf_var			= array();
	var $_ary_loop_var			= array();
	var $_ary_tmp_loop_var		= array();
	var $_ary_var				= array();
	var $_ary_block_id_current_key	= array();

	var $_link_mediation_list		= "background|href|src";	// separator: |
	var $_var_open_delim			= "{";
	var $_var_close_delim			= "}";
	var $_ctrl_open_delim			= "<!--";
	var $_ctrl_close_delim			= "-->";
	var $_ary_conf_if_close_signal		= array();	// signal: 1
	var $_ary_block_name			= array("" => array("var_name" => "ary_var", "ctrl_structure_var_name" => null));
	var $_current_block_name		= "";



	/*

	  (Constructor) Ѵ.

	 Template([string template_dir[, string compile_dir]])
	 ex) Template(), Template("./test/template", "/text/template/compile")

	*/

	function Template($template_dir = ".", $compile_dir = "./compile") {

		$this->_template_dir = $template_dir;
		$this->_compile_dir = $compile_dir;

	}



	/*

	      غѴ.

	 public void ready(string filename)
	 ex) ready("test.tpl")

	*/

	function ready($template_file) {

		if (! is_file($this->_template_dir . "/" . $template_file)) $this->report("ø  " . $this->_template_dir . "/" . $template_file . "()  ʽϴ.", "err");

		$this->_template_file = $template_file;
		$this->_compile_file = $template_file . ".php";

	}



	/*

	   Ѵ.

	 public void putConfVar(array ary_conf_var)
	 ex) putConfVar(array("conf_admin_name" => "ȫ浿"))

	*/

	function putConfVar($ary_conf_var) {

		$this->_ary_conf_var = $ary_conf_var;

	}



	/*

	 Ϲ  Ѵ.

	 public void putVar(array ary_var, string block_id)
	 ex) putVar(array("city_name" => ""), "nation.city")

	*/

	function putVar($ary_var, $block_id = '') {

		if ($block_id) {

			preg_match_all("/^(.*?)\.*([\xA1-\xFE\w_]+)$/", $block_id, $ary_match);

			if (! $ary_match[1][0]) {

				$this->_ary_loop_var[$ary_match[2][0]][$this->_ary_block_id_current_key[$block_id]] = $ary_var;
				$this->_ary_tmp_loop_var =& $this->_ary_loop_var[$ary_match[2][0]][$this->_ary_block_id_current_key[$block_id]] and $this->_ary_block_id_current_key[$block_id]++;

			} else {

				$this->_ary_tmp_loop_var[$ary_match[1][0]][$ary_match[2][0]][$this->_ary_block_id_current_key[$block_id]] = $ary_var;
				$this->_ary_tmp_loop_var[$block_id] = $this->_ary_tmp_loop_var[$ary_match[1][0]][$ary_match[2][0]][$this->_ary_block_id_current_key[$block_id]] and $this->_ary_block_id_current_key[$block_id]++;

			}

		} else $this->_ary_var = array_merge($ary_var, $this->_ary_loop_var);

	}



	/*

	 ø  ؼϿ   Ѵ.

	 public string _compile()
	 ex) _compile()

	*/

	function _compile() {

		$this->fp = fopen($this->_template_dir . "/" . $this->_template_file, "r");
		$template_statement = fread($this->fp, filesize($this->_template_dir . "/" . $this->_template_file));
		fclose($this->fp);

		if ($this->_ary_conf_var) {

			ob_start();
			$ary_conf_var =& $this->_ary_conf_var and eval("?> " . preg_replace_callback('@(?:' . $this->_var_open_delim . '([a-z][\xA1-\xFE\w_]+)' . $this->_var_close_delim . '|' . $this->_ctrl_open_delim . '\s*([a-zA-Z]+/*)\s+([\xA1-\xFE\w_]+)*\s*' . $this->_ctrl_close_delim . '|(\s*(?i)(?:' . $this->_link_mediation_list . ')\s*=\s*[\'\"]*)(?:\./)([^\'\"\s>]+[\'\"]*))@x', array($this, "_parse"), $template_statement) . "<?php ");
			$compile_statement = preg_replace_callback('/\[:\?php([\w\W]+?)\?:\]/', array($this, "_enableExec"), ob_get_contents());
			ob_end_clean();

		} else {

			$compile_statement = preg_replace_callback('@(?:' . $this->_var_open_delim . '([a-z][\xA1-\xFE\w_]+)' . $this->_var_close_delim . '|' . $this->_ctrl_open_delim . '\s*([a-zA-Z]+/*)\s+([\xA1-\xFE\w_]+)*\s*' . $this->_ctrl_close_delim . '|(\s*(?i)(?:' . $this->_link_mediation_list . ')\s*=\s*[\'\"]*)(?:\./)([^\'\"\s>]+[\'\"]*))@x', array($this, "_parseExceptConf"), $template_statement);

		}

		$fp = fopen($this->_compile_dir . "/" . $this->_compile_file, "w");
		if (! $fp) $this->report(" ø  " . $this->_compile_dir . "/" . $this->_compile_file . "()   µ Ͽϴ.", "err");
		fwrite($fp, $compile_statement);
		fclose($fp);

		return $compile_statement;

	}



	/*

	 ø  ĽѴ. (  )

	 private void _parseExceptConf(array ary_match)
	 ex) _parseExceptConf($ary_match)

	*/

	function _parseExceptConf($ary_match) {

		if ($ary_match[4]) return $ary_match[4] . $this->_template_dir . "/" . $ary_match[5];

		switch (strtolower($ary_match[2])) {

			case "":

				return '<?php echo $' . $this->_ary_block_name[$this->_current_block_name]["var_name"] . '["' . $ary_match[1] . '"]; ?>';

			case "loop":

				$this->_putBlockName($ary_match[3]);

				return '<?php if ($' . $this->_ary_block_name[$this->_current_block_name]["ctrl_structure_var_name"] . ') { foreach ($' . $this->_ary_block_name[$this->_current_block_name]["ctrl_structure_var_name"] . ' as $' . $this->_current_block_name . '_key => $ary_' . $this->_current_block_name . '_var) { ?>';

			case "loop/":

				$this->_delBlockName();

				return '<?php } } ?>';

			case "if":

				return '<?php if ($' . $this->_ary_block_name[$this->_current_block_name]["var_name"] . '["' . $ary_match[3] . '"]) { ?>';

			case "else":

				return '<?php } else { ?>';

			case "if/":

				return '<?php } ?>';

			default:

				return $ary_match[0];

		}

	}



	/*

	 ø  ĽѴ.

	 private void _parse(array ary_match)
	 ex) _parse($ary_match)

	*/

	function _parse($ary_match) {

		if ($ary_match[4]) return $ary_match[4] . $this->_template_dir . "/" . $ary_match[5];

		switch (strtolower($ary_match[2])) {

			case "":

				if (isset($this->_ary_conf_var[$ary_match[1]])) return '<?php echo $ary_conf_var["' . $ary_match[1] . '"]; ?>';
				else return '[:?php echo $' . $this->_ary_block_name[$this->_current_block_name]["var_name"] . '["' . $ary_match[1] . '"]; ?:]';

			case "loop":

				$this->_putBlockName($ary_match[3]);

				return '[:?php if ($' . $this->_ary_block_name[$this->_current_block_name]["ctrl_structure_var_name"] . ') { foreach ($' . $this->_ary_block_name[$this->_current_block_name]["ctrl_structure_var_name"] . ' as $' . $this->_current_block_name . '_key => $ary_' . $this->_current_block_name . '_var) { ?:]';

			case "loop/":

				$this->_delBlockName();

				return '[:?php } } ?:]';

			case "if":

				if (isset($this->_ary_conf_var[$ary_match[3]])) {

					array_push($this->_ary_conf_if_close_signal, 1);

					return '<?php if ($ary_conf_var["' . $ary_match[3] . '"]) { ?>';

				} else {

					if ($this->_ary_conf_if_close_signal) $this->_ary_conf_if_close_signal[count($this->_ary_conf_if_close_signal) - 1]++;

					return '[:?php if ($' . $this->_ary_block_name[$this->_current_block_name]["var_name"] . '["' . $ary_match[3] . '"]) { ?:]';

				}

			case "else":

				if ($this->_ary_conf_if_close_signal[count($this->_ary_conf_if_close_signal) - 1] == 1) return '<?php } else { ?>';
				else return '[:?php } else { ?:]';

			case "if/":

				if ($this->_ary_conf_if_close_signal[count($this->_ary_conf_if_close_signal) - 1] == 1) {

					array_pop($this->_ary_conf_if_close_signal);

					return '<?php } ?>';

				} else {

					if ($this->_ary_conf_if_close_signal) $this->_ary_conf_if_close_signal[count($this->_ary_conf_if_close_signal) - 1]--;

					return '[:?php } ?:]';

				}

			default:

				return $ary_match[0];

		}

	}



	/*

	  迭 ο  Ѵ.

	 private void _putBlockName(string block_name)
	 ex) _putBlockName("city")

	*/

	function _putBlockName($block_name) {

		$this->_ary_block_name[$block_name]["var_name"] = 'ary_' . $block_name . '_var';
		$this->_ary_block_name[$block_name]["ctrl_structure_var_name"] = ($this->_current_block_name ? $this->_ary_block_name[$this->_current_block_name]["var_name"] . '[$' . $this->_current_block_name . '_key]' : 'ary_var') . '["' . $block_name . '"]';
		$this->_current_block_name = $block_name;

	}



	/*

	  迭   Ѵ.

	 private void _delBlockName()
	 ex) _delBlockName()

	*/

	function _delBlockName() {

		array_pop($this->_ary_block_name);
		$ary_current_block_name_key = array_keys(array_slice($this->_ary_block_name, -1, 1)) and $this->_current_block_name = $ary_current_block_name_key[0];

	}



	/*

	 뿡 Ե Ϻ ڵ带  ϰ Ѵ.

	 private void _enableExec(array ary_match)
	 ex) _enableExec($ary_match)

	*/

	function _enableExec($ary_match) {

		return "<?php" . $ary_match[1] . "?>";

	}



	/*

	  ҷ´.

	 public string fetch()
	 ex) fetch()

	*/

	function fetch() {

		ob_start();

		if (! is_file($this->_compile_dir . "/" . $this->_compile_file)) {

			$ary_var =& $this->_ary_var and eval("?> " . $this->_compile() . "<?php ");

		} else {

			$this->fp = fopen($this->_compile_dir . "/" . $this->_compile_file, "r");
			$compile_statement = fread($this->fp, filesize($this->_compile_dir . "/" . $this->_compile_file));
			fclose($this->fp);

			$ary_var =& $this->_ary_var and eval("?> " . $compile_statement . "<?php ");

		}

		$statement = ob_get_contents();
		ob_end_clean();

		return $statement;

	}



	/*

	  Ѵ.

	 public void out([string header[, string footer]])
	 ex) out(), out("<!-- header -->...", "<!-- footer -->...")

	*/

	function out($header = "", $footer = "") {

		echo $header; flush();
		echo preg_replace("/<\/body>([\w\W]*)<\/html>([\w\W]*)/i", $footer . "$1$2", $this->fetch());

	}



	/*

	  ø  .

	 public void clearCompile()
	 ex) clearCompile()

	*/

	function clearCompile() {

		$dir_handle = opendir($this->_compile_dir);

		if (! $dir_handle) {

			$this->report(" ø  " . $this->_compile_dir . "() µ Ͽϴ.", "err");

			return false;

		}

		while ($filename = readdir($dir_handle)) {

			if (is_file($this->_compile_dir . "/" . $filename)) {

				chmod($this->_compile_dir . "/" . $filename, 0777);
				if (! unlink($this->_compile_dir . "/" . $filename)) return false;

			}

		}

		closedir($dir_handle);

		return true;

	}



	/*

	 α׸ Ѵ.

	 private void report(string msg, string mode)
	 ex) report("  test.php()   µ Ͽϴ.", "err")

	*/

	function report($msg, $mode) {

		if (isset($GLOBALS[Log])) $GLOBALS[Log]->report($msg, $mode);

	}


}

?>